//---------------------------------------------------------------------------
// Hadamard gate
//---------------------------------------------------------------------------
#ifndef QC_hadamardH
#define QC_hadamardH
//---------------------------------------------------------------------------
#include "QCalcUnit.h"
//---------------------------------------------------------------------------

class QC_hadamard : public QCalcUnit
{
private:
    int Target;//Target bit of calculation

public:

    QC_hadamard(int _Target);// Constructor
    static void calc(int target, double R[], double I[], int N);
    virtual void Calc(QBits *QBits);// Calclation
    virtual std::string GetName(void) const {
        return "Hadamard";
    }

#ifdef __USE__MPI
    static void calcmpi(int t1, double R[], double I[], int N);
#endif

};
//---------------------------------------------------------------------------
#endif
